//*----------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : main.c
//* Object              : Main application written in C
//* Creation            : JPP   16/Jun/2004
//* Modif               : JPM   16/Nov/2004
//*----------------------------------------------------------------------------

// Include Standard files
#include "Board.h"

extern void menu(void);

//*--------------------------------------------------------------------------------------
//* Function Name       : Main
//* Object              : Software entry point
//* Input Parameters    : none.
//* Output Parameters   : none.
//*--------------------------------------------------------------------------------------
int main()
{
    //* First, enable the clock of the PIOA
    AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_PIOA ) ;

    //* Then, we configure the PIO Lines corresponding to LEDs to be outputs
    AT91F_PIO_CfgOutput( AT91C_BASE_PIOA, LED_MASK ) ;

    //* Clear the LED's. On the SAM7S64 we must apply a "1" to turn off LEDs
    AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED_MASK ) ;
        
    //* Open PIO for DBGU
    AT91F_DBGU_CfgPIO();

    //* Configure DBGU
    AT91F_US_Configure (
		(AT91PS_USART) AT91C_BASE_DBGU,       // DBGU base address
		MCK,
		AT91C_US_ASYNC_MODE ,                 // Mode Register to be programmed
		AT91C_DBGU_BAUD ,                     // Baudrate to be programmed
		0);                                   // Timeguard to be programmed

    //* Enable Transmitter & receiver
    ((AT91PS_USART)AT91C_BASE_DBGU)->US_CR = AT91C_US_RXEN | AT91C_US_TXEN;
       
    //* Call function menu() for user interface
    menu();
}
