// IRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
// OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//*----------------------------------------------------------------------------
//* File Name           : main.c
//* Object              : main application written in C
//* Creation            : 13/Jun/05 JPP
//* V 1.00  28-Jun-2006 JPP change for EK
//*----------------------------------------------------------------------------

// Include Standard LIB  files
#include "board.h"
#include "Main.h"

volatile char message[80];
volatile int loop;
unsigned int PWM0_duty = 10, PWM1_duty = 20;	// initial PWM duty value

//*--------------------------------------------------------------------------------------
//* Function Name       : wait
//* Object              : Software waiting loop
//* Input Parameters    : none. Waiting time is defined by the global variable LedSpeed.
//* Output Parameters   : none
//*--------------------------------------------------------------------------------------

__inline void AT91F_PWMC_CfgMode(
        AT91PS_PWMC pPWM,			// pointer to a PWM controller
        unsigned int mode)			// PWM_MR register value
{
	pPWM->PWMC_MR = mode;
}

void wait ( void )
{//* Begin
	//Wait at least 10 ms
    for (loop=0; loop<120; loop++)
    {		  sprintf((char*) message," ");
	    	  AT91F_DBGU_Printk((char*)message);
    }

}//* End

//*----------------------------------------------------------------------------
//* Function Name       : menu
//* Object              : debug menu
//*----------------------------------------------------------------------------
void menu( char value)
{
	unsigned int address,tmp;
	char write;

	switch (value) {
        case '0' : if(PWM0_duty < 90)  PWM0_duty += 10; // increment PWM0 duty by 10%
                   else                PWM0_duty = 10;
                  AT91F_PWMC_UpdateChannel(AT91C_BASE_PWMC, 0, PWM0_duty);	
		//AT91F_DBGU_Printk("0x8C");    
                //AT91F_DBGU_Printk("PWM0_duty*100/100");   
                  
                  AT91F_DBGU_Printk("\n\r\n");
                  sprintf((char*) message,"PWM0_duty = 0x%x :",PWM0_duty);
		  AT91F_DBGU_Printk((char*)message);
                                    AT91F_DBGU_Printk("\n\r\n");
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 0  Էϰ ͹ ʽÿ.\n\r");
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 1  Էϰ ͹ ʽÿ.\n\r");

                   break;  
        case '1' : if(PWM1_duty < 180) PWM1_duty += 20; // increment PWM1 duty by 10%
                   else                PWM1_duty = 20;
                   AT91F_PWMC_UpdateChannel(AT91C_BASE_PWMC, 1, PWM1_duty);
                 //AT91F_DBGU_Printk("0xCC");      
                 //AT91F_DBGU_Printk("PWM1_duty*100/200)");   
                                     
                  AT91F_DBGU_Printk("\n\r\n");
                  sprintf((char*) message,"PWM0_duty = 0x%x :",PWM1_duty);
		  AT91F_DBGU_Printk((char*)message);
                                       AT91F_DBGU_Printk("\n\r\n");
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 0  Էϰ ͹ ʽÿ.\n\r");
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 1  Էϰ ͹ ʽÿ.\n\r");

                   break;
 	default:
	AT91F_DBGU_Printk("\n\r");
	break;
	}
}//* End

//*----------------------------------------------------------------------------
//* Function Name       : main
//* Object              : Main function
//*----------------------------------------------------------------------------
int main( void )
//* Begin
{
  // WARNING CUT JP24 FOR TEST SSC
   char value;
     //* Enable User Reset and set its minimal assertion to 960 us
	AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);

    //* Init DBGU
    AT91F_DBGU_Init();
    //* Polling
 
    AT91F_DBGU_Printk("\nBasicPWM TEST\n\r");

    AT91F_PWMC_CfgPMC();				// enable clock of PWMC
    AT91F_PIO_CfgPeriph(AT91C_BASE_PIOA, AT91C_PA1_PWM1 | AT91C_PA0_PWM0, 0);
  						// PWM1,PWM0 output(Peripheral A)
    
    AT91F_PWMC_CfgMode(AT91C_BASE_PWMC, 0x031E031E); // CLKA=CLKB = 48MHz/8/30 = 200kHz
    AT91F_PWMC_CfgChannel(AT91C_BASE_PWMC, 0, 0x020B, 100, PWM0_duty); // CLKA/100 = 2kHz
    AT91F_PWMC_CfgChannel(AT91C_BASE_PWMC, 1, 0x020B, 200, PWM1_duty); // CLKA/200 = 1kHz
    AT91F_PWMC_StartChannel(AT91C_BASE_PWMC, AT91C_PWMC_CHID1 | AT91C_PWMC_CHID0);
						// start PWM1 and PWM0

    //* Infinit loop
    
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 0  Էϰ ͹ ʽÿ.\n\r");
    AT91F_DBGU_Printk("\nü0 Ƽ ϰ Ҷ Ű忡Ϳ 1  Էϰ ͹ ʽÿ.\n\r");

    while(1)
    {
	if (AT91F_DBGU_Get(&value) == 0 ) menu(value);
    }// End while

}//* End
