//*----------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : main.c
//* Object              : main application written in C
//* Creation            : JPP   16/Jun/2004
//*----------------------------------------------------------------------------

// Include Standard files
#include "Board.h"

//*   Waiting time between AT91B_LED1 and AT91B_LED2
#define     WAIT_TIME       MCK

#define RTT_INTERRUPT_LEVEL     8 // 1~8  ͷƮ 1~8 ̷ 켱 ־ Ѵ.
#define AT91C_AIC_SRCTYPE_INT_EDGE_TRIGGERED   ((unsigned int) 0x1 <<  5) // (AIC) Internal Sources Code Label Edge triggered

//* Global variable

//*----------------------------------------------------------------------------
//* Function Name       : RTT_interrupt
//* Object              : RTT interrupt function
//*----------------------------------------------------------------------------
void AT91_RTT_Timer(void) //1ʿ ѹ  Լ ȣȴ.
{
     unsigned char timeChar[20];
     unsigned int time;
    //* Read the output state
    if ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & LED2 ) == LED2 )
    {
        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED2 );
    }
    else
    {
        AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED2 );
    }
 time=AT91F_RTTReadValue(AT91C_BASE_RTTC);  // rtt value о´.
// itoa(time, timeChar);
// AT91F_GLCD_DATA_OUT((unsigned char *)timeChar,3,20); //   Լ...  ׷ LCD Լ... 
// itoa(temporary++, timeChar);
// AT91F_GLCD_DATA_OUT((unsigned char *)timeChar,5,20);

 time=AT91F_RTTGetStatus(AT91C_BASE_RTTC);;// alram reset
 time=time; // ·͸    .
}

//*----------------------------------------------------------------------------
//* Function Name       : delay
//* Object              : Wait
//*----------------------------------------------------------------------------
void delay ( void )
{
//* Set in Volatile for Optimisation
    volatile unsigned int    i ;
//* loop delay
    for ( i = 0 ;(i < WAIT_TIME/100 );i++ ) ;
}

//*----------------------------------------------------------------------------
//* Function Name       : main
//* Object              : Main interrupt function
//*----------------------------------------------------------------------------
int main( void )
//* Begin
{
    unsigned int   loop_count ;
    unsigned int   prescaler;
 
// -------- AIC_CISR : (AIC Offset: 0x114) AIC Core Interrupt Status Register -------- 
       AT91PS_AIC     pAic;
    //* Load System pAic Base address
        pAic = AT91C_BASE_AIC;

    //* Enable User Reset and set its minimal assertion to 960 us
        AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);

      loop_count = 0 ;
    // First, enable the clock of the PIO for led and PIO for Switch
        AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_PIOA ) ;
    //* then, we configure the PIO Lines corresponding to AT91B_LEDx
    //* to be outputs. No need to set these pins to be driven by the
    //* PIO because it is GPIO pins only.
        AT91F_PIO_CfgOutput( AT91C_BASE_PIOA, LED_MASK ) ;
    //* Clear the AT91B_LED's. On the EK we must apply a "1" to turn off AT91B_LEDs
      AT91F_PIO_SetOutput(AT91C_BASE_PIOA , LED_MASK ) ;
    //* Clear the AT91B_LED's. On the EK we must apply a "1" to turn off AT91B_LEDs

   //* open  RTT interrupt
    AT91F_RTTC_CfgPMC(); //     // Peripheral ID Enable
    AT91F_RTTClearAlarmINT(AT91C_BASE_RTTC); // Alram Disable
    AT91F_RTTClearRttIncINT(AT91C_BASE_RTTC); // Real-Time Timer Increment Interrupt Disable
    prescaler=0x8000; //0x8000 1. 800 0.1  
    AT91F_RTTSetPrescaler(AT91C_BASE_RTTC,prescaler);

    //peripheral ID => AIC  //peripheral ID => RTT          //ͷƮ   //¿ Ʈ.    //ڵ鷯.
    AT91F_AIC_ConfigureIt (AT91C_BASE_AIC, AT91C_ID_SYS, RTT_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_INT_EDGE_TRIGGERED,AT91_RTT_Timer); 
    AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_SYS);//Interrupt Enable Register
 
  //* Generate interrupt by software
    AT91F_AIC_Trig (AT91C_BASE_AIC, AT91C_ID_SYS) ; // edge detector p154
    AT91F_RTTSetRttIncINT(AT91C_BASE_RTTC);
    AT91F_RTTSetAlarmINT(AT91C_BASE_RTTC);
    AT91F_RTTRestart(AT91C_BASE_RTTC);

for (;;)
    {
        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA,LED1 );
        delay () ;
        AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED1 );
        delay () ;
    }
//* End
}
